branch zlib error

Bug #1852789 reported by Sam Bull on 2019-11-15
6
This bug affects 1 person
Affects Status Importance Assigned to Milestone
Breezy
Undecided
Unassigned

Bug Description

Maybe related to the error on brz pull which has been marked as fixed. But, when trying to branch from that local master branch, I now get this error:

> brz branch trunk careers
brz: ERROR: zlib.error: Error -3 while decompressing data: incorrect data check

Traceback (most recent call last):
  File "/usr/local/lib/python3.7/site-packages/breezy/commands.py", line 1016, in exception_to_return_code
    return the_callable(*args, **kwargs)
  File "/usr/local/lib/python3.7/site-packages/breezy/commands.py", line 1202, in run_bzr
    ret = run(*run_argv)
  File "/usr/local/lib/python3.7/site-packages/breezy/commands.py", line 759, in run_argv_aliases
    return self.run(**all_cmd_args)
  File "/usr/local/lib/python3.7/site-packages/breezy/commands.py", line 784, in run
    return self._operation.run_simple(*args, **kwargs)
  File "/usr/local/lib/python3.7/site-packages/breezy/cleanup.py", line 137, in run_simple
    self.cleanups, self.func, *args, **kwargs)
  File "/usr/local/lib/python3.7/site-packages/breezy/cleanup.py", line 166, in _do_with_cleanups
    result = func(*args, **kwargs)
  File "/usr/local/lib/python3.7/site-packages/breezy/builtins.py", line 1518, in run
    create_tree_if_local=not no_tree, source_branch=br_from)
  File "/usr/local/lib/python3.7/site-packages/breezy/git/dir.py", line 181, in sprout
    mapping=source_branch.mapping)
  File "/usr/local/lib/python3.7/site-packages/breezy/git/interrepo.py", line 734, in fetch_objects
    progress=progress)
  File "/usr/local/lib/python3.7/site-packages/dulwich/repo.py", line 338, in fetch
    target.object_store.add_pack_data(count, pack_data, progress)
  File "/usr/local/lib/python3.7/site-packages/dulwich/object_store.py", line 151, in add_pack_data
    write_pack_data(f, count, pack_data, progress)
  File "/usr/local/lib/python3.7/site-packages/dulwich/pack.py", line 1645, in write_pack_data
    for i, (type_num, object_id, delta_base, raw) in enumerate(records):
  File "/usr/local/lib/python3.7/site-packages/dulwich/pack.py", line 1604, in <genexpr>
    ((o.type_num, o.sha().digest(), None, o.as_raw_string())
  File "/usr/local/lib/python3.7/site-packages/dulwich/object_store.py", line 957, in __iter__
    yield self.store[sha], path
  File "/usr/local/lib/python3.7/site-packages/dulwich/object_store.py", line 120, in __getitem__
    type_num, uncomp = self.get_raw(sha)
  File "/usr/local/lib/python3.7/site-packages/dulwich/object_store.py", line 462, in get_raw
    return pack.get_raw(sha)
  File "/usr/local/lib/python3.7/site-packages/dulwich/pack.py", line 2001, in get_raw
    obj_type, obj = self.data.get_object_at(offset)
  File "/usr/local/lib/python3.7/site-packages/dulwich/pack.py", line 1276, in get_object_at
    unpacked, _ = unpack_object(self._file.read)
  File "/usr/local/lib/python3.7/site-packages/dulwich/pack.py", line 764, in unpack_object
    include_comp=include_comp)
  File "/usr/local/lib/python3.7/site-packages/dulwich/pack.py", line 238, in read_zlib_chunks
    decomp = decomp_obj.decompress(add)
zlib.error: Error -3 while decompressing data: incorrect data check

brz 3.0.1 on python 3.7.4 (Darwin-18.7.0-x86_64-i386-64bit)
arguments: ['/usr/local/bin/brz', 'branch', 'trunk', 'careers']
plugins: bash_completion[3.0.1], changelog_merge[3.0.1],
    commitfromnews[unknown], cvs[3.0.1], darcs[unknown], email[unknown],
    fastimport[unknown], launchpad[3.0.1], mtn[3.0.1],
    netrc_credential_store[3.0.1], news_merge[3.0.1], po_merge[3.0.1],
    propose[unknown], repodebug[unknown], stats[3.0.1], upload[3.0.1],
    weave_fmt[3.0.1]
encoding: 'utf-8', fsenc: 'utf-8', lang: 'en_GB.UTF-8'

*** Bazaar has encountered an internal error. This probably indicates a
    bug in Bazaar. You can help us fix it by filing a bug report at
        https://bugs.launchpad.net/brz/+filebug
    including this traceback and a description of the problem.

Download full text (4.3 KiB)

Can you successfully clone the repository with C Git?

On 15 November 2019 11:21:40 GMT-08:00, Sam Bull <email address hidden> wrote:
>Public bug reported:
>
>Maybe related to the error on brz pull which has been marked as fixed.
>But, when trying to branch from that local master branch, I now get
>this
>error:
>
>> brz branch trunk careers
>brz: ERROR: zlib.error: Error -3 while decompressing data: incorrect
>data check
>
>Traceback (most recent call last):
>File "/usr/local/lib/python3.7/site-packages/breezy/commands.py", line
>1016, in exception_to_return_code
> return the_callable(*args, **kwargs)
>File "/usr/local/lib/python3.7/site-packages/breezy/commands.py", line
>1202, in run_bzr
> ret = run(*run_argv)
>File "/usr/local/lib/python3.7/site-packages/breezy/commands.py", line
>759, in run_argv_aliases
> return self.run(**all_cmd_args)
>File "/usr/local/lib/python3.7/site-packages/breezy/commands.py", line
>784, in run
> return self._operation.run_simple(*args, **kwargs)
>File "/usr/local/lib/python3.7/site-packages/breezy/cleanup.py", line
>137, in run_simple
> self.cleanups, self.func, *args, **kwargs)
>File "/usr/local/lib/python3.7/site-packages/breezy/cleanup.py", line
>166, in _do_with_cleanups
> result = func(*args, **kwargs)
>File "/usr/local/lib/python3.7/site-packages/breezy/builtins.py", line
>1518, in run
> create_tree_if_local=not no_tree, source_branch=br_from)
>File "/usr/local/lib/python3.7/site-packages/breezy/git/dir.py", line
>181, in sprout
> mapping=source_branch.mapping)
>File "/usr/local/lib/python3.7/site-packages/breezy/git/interrepo.py",
>line 734, in fetch_objects
> progress=progress)
>File "/usr/local/lib/python3.7/site-packages/dulwich/repo.py", line
>338, in fetch
> target.object_store.add_pack_data(count, pack_data, progress)
>File "/usr/local/lib/python3.7/site-packages/dulwich/object_store.py",
>line 151, in add_pack_data
> write_pack_data(f, count, pack_data, progress)
>File "/usr/local/lib/python3.7/site-packages/dulwich/pack.py", line
>1645, in write_pack_data
> for i, (type_num, object_id, delta_base, raw) in enumerate(records):
>File "/usr/local/lib/python3.7/site-packages/dulwich/pack.py", line
>1604, in <genexpr>
> ((o.type_num, o.sha().digest(), None, o.as_raw_string())
>File "/usr/local/lib/python3.7/site-packages/dulwich/object_store.py",
>line 957, in __iter__
> yield self.store[sha], path
>File "/usr/local/lib/python3.7/site-packages/dulwich/object_store.py",
>line 120, in __getitem__
> type_num, uncomp = self.get_raw(sha)
>File "/usr/local/lib/python3.7/site-packages/dulwich/object_store.py",
>line 462, in get_raw
> return pack.get_raw(sha)
>File "/usr/local/lib/python3.7/site-packages/dulwich/pack.py", line
>2001, in get_raw
> obj_type, obj = self.data.get_object_at(offset)
>File "/usr/local/lib/python3.7/site-packages/dulwich/pack.py", line
>1276, in get_object_at
> unpacked, _ = unpack_object(self._file.read)
>File "/usr/local/lib/python3.7/site-packages/dulwich/pack.py", line
>764, in unpack_object
> include_comp=include_comp)
>File "/usr/local/lib/python3.7/site-packages/dulwich/pack.py", line
>238, in read_zlib_chunks
> decomp...

Read more...

Jelmer Vernooij (jelmer) on 2019-11-17
Changed in brz:
status: New → Incomplete
Sam Bull (dreamsorcerer) wrote :

Output from git:
> git clone trunk test123
Cloning into 'test123'...
done.

hint: The remote resolves to a file:// URL, which can only work with a
hint: standalone transfer agent. See section "Using a Custom Transfer Type
hint: without the API server" in custom-transfers.md for details.

hint: The remote resolves to a file:// URL, which can only work with a
hint: standalone transfer agent. See section "Using a Custom Transfer Type
hint: without the API server" in custom-transfers.md for details.
^Cwarning: Clone succeeded, but checkout failed.
You can inspect what was checked out with 'git status'
and retry the checkout with 'git checkout -f HEAD'

Exiting because of "interrupt" signal.

--

So, it hung (and I used Ctrl+C after a few minutes), although it looked like the files were there. So, it performed better than breezy, but still got stuck. I guess that means breezy managed to corrupt the repo in some way.

The original trunk repo was created by breezy?

What happens if you run 'git fsck' in it?

On 18 November 2019 11:54:51 GMT-08:00, Sam Bull <email address hidden> wrote:
>Output from git:
>> git clone trunk test123
>Cloning into 'test123'...
>done.
>
>hint: The remote resolves to a file:// URL, which can only work with a
>hint: standalone transfer agent. See section "Using a Custom Transfer
>Type
>hint: without the API server" in custom-transfers.md for details.
>
>hint: The remote resolves to a file:// URL, which can only work with a
>hint: standalone transfer agent. See section "Using a Custom Transfer
>Type
>hint: without the API server" in custom-transfers.md for details.
>^Cwarning: Clone succeeded, but checkout failed.
>You can inspect what was checked out with 'git status'
>and retry the checkout with 'git checkout -f HEAD'
>
>
>Exiting because of "interrupt" signal.
>
>
>--
>
>So, it hung (and I used Ctrl+C after a few minutes), although it looked
>like the files were there. So, it performed better than breezy, but
>still got stuck. I guess that means breezy managed to corrupt the repo
>in some way.
>
>--
>You received this bug notification because you are subscribed to
>Breezy.
>https://bugs.launchpad.net/bugs/1852789
>
>Title:
> branch zlib error
>
>To manage notifications about this bug go to:
>https://bugs.launchpad.net/brz/+bug/1852789/+subscriptions

Sam Bull (dreamsorcerer) wrote :
Download full text (4.8 KiB)

Yep, this is the same repo that I can't run 'brz revert' on, so I keep pulling and causing more conflicts, but can then branch from it fine.

> git fsck
Checking object directories: 100% (256/256), done.
Checking objects: 100% (32548/32548), done.
dangling blob 8e1182f883ea4e3697ff85e12c9581514b11e41f
dangling blob b91e0ee1ee24ce02c09ec2d70b78e7fedcc9dc96
dangling blob 4027c81f19808e55d5fc3023637c8f9df0a0e6c5
dangling blob 4f28c26ad2f2a22871e8b717bf35b6bea24a685e
dangling blob 3939b42848253fffcfab9af0d9cbacf0866e101c
dangling tree f33c8ef535aec72e55ce191e65966757fe0907e8
dangling blob 1c3f10aeefe3df7a90a898bcc6d83c5562a4603d
dangling blob 074b249f77df18a042d1c834674ebcf32320341b
dangling blob 805190d406050db7170f44b728379e784fef3b0c
dangling blob 355200c32de40d98bdf7ba950156ec4b0137c42d
dangling blob 815cc4c1cd411b4334a9e5639b857d8e5bc47f68
dangling tree da66122f1b1a410cd98efa5133d8516a6043a0a9
dangling tree 1679b26360b963d352cbe38ff32f9a216f4511be
dangling tree 2a89968f712b8cff212808fce38f1701b8fc0c76
dangling tree 01b73ed8e49065b51b67c367ed77ddaeddfc5e82
dangling blob e5bbf4691847eb5c1efa4f5e7230df23b3cdb945
dangling tree 16c3cccb7573fd758a2cca4201787011578bffc5
dangling blob 5cf7303e6d2a1d815e2bbca2fc91ab60c756ba5d
dangling blob 3e0c8d88af336fab891adabad089b53727e752dc
dangling blob be0c13b1527218bb10b330c8064665328fca6d8f
dangling blob 1b0e01822fcbb0271d8b7d4bcddac9c40692af8b
dangling blob f00ffff92736203249150fd69dd50f0e3de03293
dangling blob f71485a1eef926fcdf35857691a6539cafd6fff8
dangling blob 7c18d54ce7644677f6ee7f3145035f176a7bbf4d
dangling blob 8125f19347c4f724e8a847d085da43b4ba011622
dangling blob bb2c8b7c7f6904a2c2ca07da8b9ed6250b2f86fc
dangling blob 2d47a50a91fba5394a0ceb0c6736bacf91df1165
dangling tree 1962d3ed5cf985cdb1386d650d837918ffd4d83b
dangling blob dc692744e47312190176e4f41e2e19d3d4504098
dangling tree 6e6b793d075e2869dce2c098af9673e8c22a5c44
dangling tree 997d19e80a8b648e31edb2549ad9fa89939e2da5
dangling blob 93ab4d24eef874955066a58c033de3346339dd43
dangling blob edb84fa9468e561c066ccf7c455a8aa2d95b2de6
dangling tree f9c9819601cea4235c9ec57e26ec05609e698c28
dangling blob 78d1f3dd4308d5164d848ef31656a5b02376b807
dangling blob 2ed2134a4091b691992a931f33a5b84e90e2fcac
dangling tree 71d2550007fd8811154b925ab58f77c3db755e64
dangling tree efd56f39765bd8fedcc168eb8505800c5a727ee2
dangling tree 4fd875b82b0b4c7faa8c8ddb07f59c5d2ec7267d
dangling tree a6d805a4dcde5baca7a555ed6371f09ddcdaddbf
dangling blob 0dda3f173b53f339052bef0c31ccc46e3c3e8a53
dangling blob 67dae9db9cf0f5d13f5853daa377d3c67d47a82d

After running that, and updating to 3.0.2, creating a branch is working again. However, revert is still failing (I think that bug was marked as fixed):

> brz revert
brz: ERROR: StopIteration:

Traceback (most recent call last):
  File "/usr/local/lib/python3.7/site-packages/breezy/commands.py", line 1016, in exception_to_return_code
    return the_callable(*args, **kwargs)
  File "/usr/local/lib/python3.7/site-packages/breezy/commands.py", line 1202, in run_bzr
    ret = run(*run_argv)
  File "/usr/local/lib/python3.7/site-packages/breezy/commands.py", line 759, in run_argv_aliases
    return self.run(**all_cmd_args)
  File "/usr/l...

Read more...

Jelmer Vernooij (jelmer) wrote :

The revert issue is only fixed in trunk, not in the 3.0 branch (which you're running). We should possibly backport that fix.

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers